Ubuntu 下安装Thinkpad T400硬盘保护APS


今天终于把这个问题搞定,记录下,网上那些文章说得不全,主要是给的网址下不了文件。在XP下安装APS很简单,直接安装就好。

在Ubuntu下就比较麻烦了,一直以来就想解决这个问题,在网上也搜了一些资料看,如:试着做了下,都不成功。

今天下了决心一定要把这个问题解决,就完全按照资料的顺序全部重新做一遍,一直到使用

$ sudo hdapsd -d sda -s 15 -a -v -y

来显示数据都是成功的,下一步

$ wget http://www.unet.univie.ac.at/~a0604095/hdapsd

这里就下载不了hdapsd这个文件,就通过下deb包,把hdapsd分离出来,并且需要两       个不同的hdapsd文件,一个位于/etc/init.d/,另一个位于/etc/default/(末尾附这两个  文件代码),然后,必须要执行$sudo /etc/init.d/hdapsd restart才能正常工作,不可能每次开机都去输入这条命令吧。

于是要使它开机自己运行,要把它放在/etc/rc2.d/下面,做一个软链接

$sudo ln -s /etc/init.d/hdapsd /etc/rc2.d/S99hdapsd

问题全部解决,开机自动工作,保护硬盘。

附:

/etc/default/hdapsd:

# hdapsd default file

# start hdapsd at boottime?

START="yes"

# the name of the disk device that hdapsd should monitor.

#

# usually this is 'hda' for the primary IDE master or 'sda'

# for the primary S-ATA drive

DISK="sda"

# sensitivity

SENSITIVITY=15

# other options to pass to hdapsd.

# the -d $DISK, -s $SENSITIVITY, -b and -p $PIDFILE options are always passed.

OPTIONS=""

# The new interface in kernels >=2.6.28 sometimes wrongly detects HDAPS-capable

# drives as not supported. Set this to "yes" to force-enable the feature.

# Please be carefull with this setting!

FORCEENABLE="no"


/etc/init.d/hdapsd

#! /bin/sh

### BEGIN INIT INFO

# Provides: hdapsd

# Required-Start: $local_fs $remote_fs

# Required-Stop: $local_fs $remote_fs

# Default-Start: 2 3 4 5

# Default-Stop: 0 1 6

# Short-Description: initscript to start hdapsd

# Description: This file starts the hdapsd daemon

### END INIT INFO

# Author: Evgeni Golov <sargentd@die-welt.net>

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script

PATH=/sbin:/usr/sbin:/bin:/usr/bin

DESC="IBM Hard Disk Active Protection System (HDAPS) daemon"

NAME=hdapsd

DAEMON=/usr/sbin/$NAME

DAEMON_ARGS=""

PIDFILE=/var/run/$NAME.pid

SCRIPTNAME=/etc/init.d/$NAME

START="no"

DISK="sda"

SENSITIVITY=15

OPTIONS=""

FORCEENABLE="no"

# Exit if the package is not installed

[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present

[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Do we really want to start the daemon?

[ "$START" = "yes" ] || exit 0

# Load the VERBOSE setting and other rcS variables

. /lib/init/vars.sh

# Define LSB log_* functions.

# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.

. /lib/lsb/init-functions

DAEMON_ARGS="-p$PIDFILE -d $DISK -s $SENSITIVITY -b $OPTIONS"

if [ "$FORCEENABLE" = "yes" ]; then

DAEMON_ARGS="$DAEMON_ARGS -f"

fi

#

# Function that checks if /sys/block/$DISK/queue/protect

# or /sys/block/$DISK/device/unload_heads exist

#

do_checkprotect()

{

if [ ! -f /sys/block/$DISK/queue/protect -a ! -f /sys/block/$DISK/device/unload_heads ]; then

log_warning_msg "Not starting $NAME: neither /sys/block/$DISK/queue/protect nor /sys/block/$DISK/device/unload_heads do exist, please read /usr/share/doc/hdapsd/README.Debian"

exit 0

fi

}

#

# Function that starts the daemon/service

#

do_start()

{

# Return

# 0 if daemon has been started

# 1 if daemon was already running

# 2 if daemon could not be started

start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \ || return 1

start-stop-daemon --start --quiet --exec $DAEMON -- $DAEMON_ARGS \ || return 2

# Add code here, if necessary, that waits for the process to be ready

# to handle requests from services started subsequently which depend

# on this one. As a last resort, sleep for some time.

}

#

# Function that stops the daemon/service

#

do_stop()

{

# Return

# 0 if daemon has been stopped

# 1 if daemon was already stopped

# 2 if daemon could not be stopped

# other if a failure occurred

start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME

RETVAL="$?"

[ "$RETVAL" = 2 ] && return 2

# Wait for children to finish too if this is a daemon that forks

# and if the daemon is only ever run from this initscript.

# If the above conditions are not satisfied then add some other code

# that waits for the process to drop all resources that could be

# needed by services started subsequently. A last resort is to

# sleep for some time.

start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON

[ "$?" = 2 ] && return 2

# Many daemons don't delete their pidfiles when they exit.

rm -f $PIDFILE

return "$RETVAL"

}

#

# Function that sends a SIGUSR1 to the daemon/service

#

do_pause() {

start-stop-daemon --stop --signal 10 --quiet --pidfile $PIDFILE --name $NAME

return 0

}

case "$1" in

start)

do_checkprotect

[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"

do_start

case "$?" in

0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;

2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;

esac

;;

stop)

[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"

do_stop

case "$?" in

0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;

2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;

esac

;;

pause)

[ "$VERBOSE" != no ] && log_daemon_msg "Pauseing (8sec) $DESC" "$NAME"

do_pause

;;

restart|force-reload)

#

# If the "reload" option is implemented then remove the

# 'force-reload' alias

#

log_daemon_msg "Restarting $DESC" "$NAME"

do_stop

case "$?" in

0|1)

do_start

case "$?" in

0) log_end_msg 0 ;;

1) log_end_msg 1 ;; # Old process is still running

*) log_end_msg 1 ;; # Failed to start

esac

;;

*)

# Failed to stop

log_end_msg 1

;;

esac

;;

*)

echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload|pause}" >&2

exit 3

;;

esac

  • 1
  • 2
  • 下一页

相关内容